-- Only load once
if WRL and WRL.loading then goto EOF end

WRL.API = {}

local http_request = http.request

-- Callback format: function(direct_url)
function WRL.API.upload(filename, filepath, string_data, callback)
    
    local filehandle
    if filepath then
        filehandle = io.open(filepath, "rb")
    end
    
    local len = 0
    
    if filehandle then
        len = filehandle:seek("end")
        filehandle:seek("set")
        string_data = filehandle:read("*a")
        filehandle:seek("set")
    end
    
    if string_data then
        len = string.len(string_data)
    end
    
    print("Uploading " .. len .. " bytes...")
    
    local boundary = '--WRUploadsy879iuhjkn89iuwbkyjs'
    local header_b = 'Content-Disposition: form-data; name="file"; filename="' .. filename .. '"\r\nContent-Type: text/plain\r\n'
    
    local s1 = '--' .. boundary .. '\r\n' ..header_b ..'\r\n'
    --[[
    local s2 = (filehandle and ltn12.source.file(filehandle)) or ltn12.source.string(string_data)
    ]]
    local s2 = string_data
    local s3 = '\r\n--' .. boundary ..'--\r\n'
    local source = s1 .. s2 .. s3
    local source_len = tostring(#s1 + len + #s3)
    
    --[[
    local source_len = s1:len() + len + s3:len()
    local source = ltn12.source.cat(
        ltn12.source.string(s1),
        s2,
        ltn12.source.string(s3))
    ]]
    
    http_request("https://codeawebrepo.co.uk/api/upload",
        function(response, status)
            if response == nil then
                print(status)
                callback(nil)
            elseif status == 200 then
                response = json.decode(response)
                callback("https://codeawebrepo.co.uk/uploads/" .. response.filename)
            else
                print(status, response)
                callback(nil)
            end
        end,
        function(err)
            objc.warning(err)
        end,
        {
            method = "POST",
            headers = {
                ["Content-Length"] = source_len,
                ["Content-Type"] = 'multipart/form-data; boundary=' .. boundary    
            },
            data = source
        }
    )
    
    -- Disabled until LuaSocket has been updated
    -- https://github.com/lunarmodules/luasocket/pull/334
    --[[
    local response_body = {}
    local _, code, _, err = socket.http.request {
        url = "https://api.bayfiles.com/upload",
        method = "POST",
        headers = {
            ["Content-Length"] = source_len,
            ["Content-Type"] = 'multipart/form-data; boundary=' .. boundary    
        },
        source = source,
        sink = ltn12.sink.table(response_body),
    }
    
    if code == 200 then
        local response = json.decode(table.concat(response_body))
        callback(response.data.file.url.short)
    else
        print(code, table.concat(response_body))
        callback(nil)
    end
    ]]
end

::EOF::