-- Only load once
if WRL and WRL.loading then goto EOF end

local function stripDocPrefix(str)
    return str:gsub(".-/Documents/", "")
end

local fhnd = io.tmpfile()
assert(fhnd ~= nil)

WRL.Trace = {
    channels = { -- enabled?, print?
        ["info"] = { true, false },
        ["downloads"] = { true, false },
    }
}
local channels = WRL.Trace.channels
setmetatable(WRL.Trace, {
    __call = function(t, channel, ...)
        -- Only trace if channel is enabled
        local ch = channels[channel]
        if ch == nil then return end
        if ch[1] ~= true then return end
        
        local info = debug.getinfo(2)
        local prefix = table.concat({
            "[", channel, "] <",
            stripDocPrefix(info.short_src), ':',
            info.currentline, ':',
            info.name or "?", '>'
        })
        
        local str = prefix
        for _,v in ipairs({...}) do
            str = str .. '\t' .. tostring(v)
        end
        
        if ch[2] then
            print(str)
        end
        
        fhnd:write(str .. '\n')
    end
})

function WRL.Trace.Get()
    local len = fhnd:seek()
    fhnd:seek("set", 0)
    return fhnd:read("*a")
end

function WRL.Trace.ConfigureChannel(id, enable, print)
    channels[id] = { enable, print }
end

WRL.Trace("info", "START OF TRACE")

::EOF::